unit SynVlakna_f;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TTextThread=class(TThread)
      procedure execute; override;
      procedure ObnovText;
      procedure ZjistiText;
    end;

  TDalsiThread=class(TThread)
     procedure Execute; override;
     procedure ZvetsitText;
    private
      velkyText:string;
      up:boolean;
    end;


  TForm1 = class(TForm)
    Label1: TLabel;
    Button2: TButton;
    Button3: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  vlakno:TTextThread;
  DalsiVlakno:TDalsiThread;
  Form1: TForm1;
  text:String;
  Sekce:TRTLCriticalSection;
implementation

{$R *.DFM}

procedure TTextThread.execute;
var s:string;
    i:integer;
begin
  repeat
    EnterCriticalSection(Sekce);
    try
      Synchronize(ZjistiText);
      s:=text;
      for i:=1 to 10000 do
        Text:=copy(s,1,1);
      delete(s,1,1);
      text:=s+Text;
      synchronize(ObnovText);
    finally
      LeaveCriticalSection(Sekce);
    end;
  until terminated;
end;

procedure TTextThread.ObnovText;
begin
  Form1.Label1.Caption:=text;
end;

procedure TTextThread.ZjistiText;
begin
  text:=form1.label1.Caption;
end;

procedure TDalsiThread.Execute;
var i,j:integer;
    s:string;
begin
  EnterCriticalSection(Sekce);    //obsazen kritick sekce
  try
    s:=Text;
    velkyText:='';
    j:=0;
    While j<10 do     //zpoujc smyka
     j:=j+1;

    for i:=1 to Length(s) do
//podle toho kter bylo stisknut tlatko, pevst text na mal nebo velk psmena
      if up then VelkyText:=velkyText+UpperCase(copy(s,i,1))
      else VelkyText:=velkyText+LowerCase(copy(s,i,1));
      text:=VelkyText;        //upraven text vrtit do promnn text
      synchronize(ZvetsitText); //promnnou text zkoprovat do titulku
   finally
      LeaveCriticalSection(Sekce); //uvolnn kritick sekce
   end;
end;


procedure TDalsiThread.ZvetsitText;
begin
  Form1.Label1.Caption:=Text;
end;


procedure TForm1.FormCreate(Sender: TObject);
begin
  InitializeCriticalSection(Sekce);   //vytvoen kritick sekce
  Label1.Caption:=Label1.Caption+'   ';
  vlakno:=TTextThread.Create(False); //vytvoen hlavnho vlkna
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  Vlakno.free;  //zruen vlkna
  DeleteCriticalSection(Sekce); //zruen kritick sekce
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  DalsiVlakno:=TDalsiThread.Create(True); //vytvoen novho pozastavenho vlkna
  DalsiVlakno.Up:=True; //nastaven smru pevodu
  DalsiVlakno.Resume; //sputn vlkna
  DalsiVlakno.Free;  //zruen vlkna
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  DalsiVlakno:=TDalsiThread.Create(true);
  DalsiVlakno.Up:=False;
  DalsiVlakno.Resume;
  DalsiVlakno.Free;
end;

end.
