unit SwitchImpl1;

{$WARN SYMBOL_PLATFORM OFF}

interface

uses
  Windows, ActiveX, Classes, Controls, Graphics, Menus, Forms, StdCtrls,
  ComServ, StdVCL, AXCtrls, State_TLB, Switch;

type
  TSwitchX = class(TActiveXControl, ISwitchX)
  private
    { Private declarations }
    FDelphiControl: TSwitch;
    FEvents: ISwitchXEvents;
    procedure ChangeEvent(Sender: TObject);
  protected
    { Protected declarations }
    procedure DefinePropertyPages(DefinePropertyPage: TDefinePropertyPage); override;
    procedure EventSinkChanged(const EventSink: IUnknown); override;
    procedure InitializeControl; override;
    function DrawTextBiDiModeFlagsReadingOnly: Integer; safecall;
    function Get_AlignDisabled: WordBool; safecall;
    function Get_Cursor: Smallint; safecall;
    function Get_DoubleBuffered: WordBool; safecall;
    function Get_Enabled: WordBool; safecall;
    function Get_Frame3D: WordBool; safecall;
    function Get_HelpKeyword: WideString; safecall;
    function Get_HelpType: TxHelpType; safecall;
    function Get_State: TxSwitchState; safecall;
    function Get_Visible: WordBool; safecall;
    function Get_VisibleDockClientCount: Integer; safecall;
    function IsRightToLeft: WordBool; safecall;
    function Switch: TxSwitchState; safecall;
    function UseRightToLeftReading: WordBool; safecall;
    function UseRightToLeftScrollBar: WordBool; safecall;
    procedure InitiateAction; safecall;
    procedure Set_Cursor(Value: Smallint); safecall;
    procedure Set_DoubleBuffered(Value: WordBool); safecall;
    procedure Set_Enabled(Value: WordBool); safecall;
    procedure Set_Frame3D(Value: WordBool); safecall;
    procedure Set_HelpKeyword(const Value: WideString); safecall;
    procedure Set_HelpType(Value: TxHelpType); safecall;
    procedure Set_State(Value: TxSwitchState); safecall;
    procedure Set_Visible(Value: WordBool); safecall;
    procedure SetSubComponent(IsSubComponent: WordBool); safecall;
    procedure TurnOff; safecall;
    procedure TurnOn; safecall;
  end;

implementation

uses ComObj;

{ TSwitchX }

procedure TSwitchX.DefinePropertyPages(DefinePropertyPage: TDefinePropertyPage);
begin
  {TODO: Define property pages here.  Property pages are defined by calling
    DefinePropertyPage with the class id of the page.  For example,
      DefinePropertyPage(Class_SwitchXPage); }
end;

procedure TSwitchX.EventSinkChanged(const EventSink: IUnknown);
begin
  FEvents := EventSink as ISwitchXEvents;
end;

procedure TSwitchX.InitializeControl;
begin
  FDelphiControl := Control as TSwitch;
  FDelphiControl.OnChange := ChangeEvent;
end;

function TSwitchX.DrawTextBiDiModeFlagsReadingOnly: Integer;
begin
  Result := FDelphiControl.DrawTextBiDiModeFlagsReadingOnly;
end;

function TSwitchX.Get_AlignDisabled: WordBool;
begin
  Result := FDelphiControl.AlignDisabled;
end;

function TSwitchX.Get_Cursor: Smallint;
begin
  Result := Smallint(FDelphiControl.Cursor);
end;

function TSwitchX.Get_DoubleBuffered: WordBool;
begin
  Result := FDelphiControl.DoubleBuffered;
end;

function TSwitchX.Get_Enabled: WordBool;
begin
  Result := FDelphiControl.Enabled;
end;

function TSwitchX.Get_Frame3D: WordBool;
begin
  Result := FDelphiControl.Frame3D;
end;

function TSwitchX.Get_HelpKeyword: WideString;
begin
  Result := WideString(FDelphiControl.HelpKeyword);
end;

function TSwitchX.Get_HelpType: TxHelpType;
begin
  Result := Ord(FDelphiControl.HelpType);
end;

function TSwitchX.Get_State: TxSwitchState;
begin
  Result := Ord(FDelphiControl.State);
end;

function TSwitchX.Get_Visible: WordBool;
begin
  Result := FDelphiControl.Visible;
end;

function TSwitchX.Get_VisibleDockClientCount: Integer;
begin
  Result := FDelphiControl.VisibleDockClientCount;
end;

function TSwitchX.IsRightToLeft: WordBool;
begin
  Result := FDelphiControl.IsRightToLeft;
end;

function TSwitchX.Switch: TxSwitchState;
begin
 Result := TxSwitchState(FDelphiControl.Switch);
end;

function TSwitchX.UseRightToLeftReading: WordBool;
begin
  Result := FDelphiControl.UseRightToLeftReading;
end;

function TSwitchX.UseRightToLeftScrollBar: WordBool;
begin
  Result := FDelphiControl.UseRightToLeftScrollBar;
end;

procedure TSwitchX.ChangeEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnChange;
end;

procedure TSwitchX.InitiateAction;
begin
  FDelphiControl.InitiateAction;
end;

procedure TSwitchX.Set_Cursor(Value: Smallint);
begin
  FDelphiControl.Cursor := TCursor(Value);
end;

procedure TSwitchX.Set_DoubleBuffered(Value: WordBool);
begin
  FDelphiControl.DoubleBuffered := Value;
end;

procedure TSwitchX.Set_Enabled(Value: WordBool);
begin
  FDelphiControl.Enabled := Value;
end;

procedure TSwitchX.Set_Frame3D(Value: WordBool);
begin
  FDelphiControl.Frame3D := Value;
end;

procedure TSwitchX.Set_HelpKeyword(const Value: WideString);
begin
  FDelphiControl.HelpKeyword := String(Value);
end;

procedure TSwitchX.Set_HelpType(Value: TxHelpType);
begin
  FDelphiControl.HelpType := THelpType(Value);
end;

procedure TSwitchX.Set_State(Value: TxSwitchState);
begin
  FDelphiControl.State := TSwitchState(Value);
end;

procedure TSwitchX.Set_Visible(Value: WordBool);
begin
  FDelphiControl.Visible := Value;
end;

procedure TSwitchX.SetSubComponent(IsSubComponent: WordBool);
begin
  FDelphiControl.SetSubComponent(IsSubComponent);
end;

procedure TSwitchX.TurnOff;
begin
  FDelphiControl.TurnOff;
end;

procedure TSwitchX.TurnOn;
begin
  FDelphiControl.TurnOn;
end;

initialization
  TActiveXControlFactory.Create(
    ComServer,
    TSwitchX,
    TSwitch,
    Class_SwitchX,
    1,
    '',
    0,
    tmApartment);
end.
